unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, BufDataset, DB, Forms, Controls, Graphics, Dialogs, ComCtrls, DBGrids, DBCtrls, Grids;

type
  // Copy in your code with tdbgrid from here ...
  TDBGrid = class(DBGrids.TDBGrid)
  public
    function  DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    function  DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    property Datalink;
    property VisibleRowCount;
    property MouseWheelOption;
    property TopRow;
    property Row;
  end;

  TComponentDataLink = class(DBGrids.TComponentDataLink)
  public
    function  MoveBy(Distance: Integer): Integer; override;
  end;
  // ... until here

  { TForm1 }

  TForm1 = class(TForm)
    BfDs1: TBufDataset;
    DBNavigator1: TDBNavigator;
    Ds1: TDataSource;
    DBGr1: TDBGrid;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    BtnPageUp: TToolButton;
    BtnPageDown: TToolButton;
    ToolButton2: TToolButton;
    BtnmwGrid: TToolButton;
    procedure BtnmwGridClick(Sender: TObject);
    procedure BtnPageDownClick(Sender: TObject);
    procedure BtnPageUpClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

// Copy in your code with tdbgrid from here ...
function TDBGrid.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := False;
  if Assigned(OnMouseWheelUp) then
    OnMouseWheelUp(Self, Shift, MousePos, Result);
  if not Result and Datalink.Active then begin
    if MouseWheelOption=mwGrid then TComponentDataLink(Datalink).MoveBy(-VisibleRowCount*2+1)
    else TComponentDataLink(Datalink).MoveBy(-1);
    Result := True;
  end;
end;

function TDBGrid.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := False;
  if Assigned(OnMouseWheelDown) then
    OnMouseWheelDown(Self, Shift, MousePos, Result);
  if not Result and Datalink.Active then begin
    if MouseWheelOption=mwGrid then TComponentDataLink(Datalink).MoveBy(VisibleRowCount*2-Row)
    else TComponentDataLink(Datalink).MoveBy(1);
    Result := True;
  end;
end;

function TComponentDataLink.MoveBy(Distance: Integer): Integer;
begin
  Result:=inherited MoveBy(Distance);
end;
// ... until here

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var i: integer;
begin
  DBGr1.MouseWheelOption:=mwGrid; //mwGrid=Seitenweise, mwScroll=Zeilenweise

  BfDs1.CreateDataset;
  BfDs1.DisableControls;
  for i:=1 to 100 do begin
    BfDs1.Append;
    BfDs1.FieldByName('BfDs1Info').AsString:='Row '+IntToStr(i);
    BfDs1.Post;
  end;
  BfDs1.First;
  BfDs1.EnableControls;
end;

procedure TForm1.BtnmwGridClick(Sender: TObject);
begin
  if BtnmwGrid.Down then DBGr1.MouseWheelOption:=mwGrid
  else DBGr1.MouseWheelOption:=mwCursor;
end;

procedure TForm1.BtnPageDownClick(Sender: TObject);
begin
  //Application.MainForm.Caption:=IntToStr(DBGr1.VisibleRowCount)+' : '+IntToStr(DBGr1.Row);
  if DBGr1.MouseWheelOption=mwGrid then TComponentDataLink(DBGr1.Datalink).MoveBy(DBGr1.VisibleRowCount*2-DBGr1.Row)
  else TComponentDataLink(DBGr1.Datalink).MoveBy(1);
end;


procedure TForm1.BtnPageUpClick(Sender: TObject);
begin
  if DBGr1.MouseWheelOption=mwGrid then TComponentDataLink(DBGr1.Datalink).MoveBy(-DBGr1.VisibleRowCount*2+1)
  else TComponentDataLink(DBGr1.Datalink).MoveBy(-1);
end;

end.

